package PersonalStructure;
import defaultpackage.Structure;

public class ChainedList implements Structure {
	protected Link head;
	protected Cursor cursor;
	protected int nbVal;
	
	public ChainedList(Link head, Cursor cursor) {
		this.head = head;
		this.cursor = cursor;
		this.nbVal = 1;
	}

	public ChainedList(Cursor cursor) {
		this.cursor = cursor;
		this.cursor.setList(this);
		this.nbVal = 0;
	}
	

	
	public void setNextLink(Link currentLink)
	{
		Link last_next = this.cursor.currentLink.next;
		this.cursor.currentLink.next = currentLink;
		nbVal+=1;
	}
	
	public void setPreviousLink(Link currentLink)
	{
		Link last_next = this.cursor.currentLink.next;
		this.cursor.currentLink.next = currentLink;
		nbVal+=1;
	}
	
	public Link getLink()
	{
		return this.cursor.currentLink;
	}
	
	public Cursor getCursor()
	{
		return this.cursor;
	}
	
	public Link getNextLink()
	{
		return this.cursor.currentLink.next;
	}
	
	public Link getPreviousLink()
	{
		return this.cursor.currentLink.next;
	}
	
	public void replaceCursor(int position)
	{
		this.cursor.position(position);
	}
	
	public boolean isEmpty() {
		boolean res = false;
		if(this.nbVal != 0)
			res = true;
		return res;
	}

	@Override
	public void Add(int value) {
		if (nbVal == 0) {
			Link new_link = new Link(value);
			this.head = new_link;
			this.head.last = new_link;

			this.cursor.currentLink = new_link;

			this.head.next = new_link;
		}
		else {
			System.out.println("val = " + value);		
			this.replaceCursor(this.nbVal);
		
			Link last_before_added = this.cursor.currentLink.last;
			Link next_after_added = this.head;
		
			Link new_link = new Link(value, next_after_added, last_before_added);

			last_before_added.next = new_link;
			this.head.last = new_link;
		
			this.cursor.currentLink = new_link;
		}
		this.nbVal += 1;
		System.out.println("nbVal = " + this.nbVal);		
	}

	@Override
	public void Remove(int index) throws Exception {
		if ((index < 0) && isEmpty())
			throw new IndexOutOfBoundsException("Wrong position");
		
		this.replaceCursor(index);
		Link last_of_remove = this.cursor.currentLink.last;
		Link next_of_remove = this.cursor.currentLink.next;
		
		last_of_remove.next = next_of_remove;
		next_of_remove.last = last_of_remove;
		
		this.cursor.currentLink = next_of_remove;
	}

	@Override
	public int Select(int index) throws Exception {
		if ((index < 0) && isEmpty())
			throw new IndexOutOfBoundsException("Wrong position");
		this.replaceCursor(index);
		return this.cursor.currentLink.value;
	}
}
